/*
 * Part of the PiyoPiyoJ project.
 * (PiyoPiyo Java)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE
 *                    Version 2, December 2004
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net>
 *
 * Everyone is permitted to copy and distribute verbatim or modified
 * copies of this license document, and changing it is allowed as long
 * as the name is changed.
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */

package piyopiyoj;

import libpiyo.PiyoPiyoPlayer;

/**
 * Holder for player control information
 * Created on March 2nd, 2018
 */
public class PlayerControls {
    public boolean playing, reverse, halfSpeed;
    public final PiyoPiyoPlayer target;

    public PlayerControls(PiyoPiyoPlayer targ) {
        target = targ;
    }

    // NOTE: This runs on the audio thread.
    public void runTick(double deltaTime) {
        double speed = halfSpeed ? (deltaTime / 2.0d) : deltaTime;
        if (playing)
            target.updateBeats(reverse ? -speed : speed);
        target.updateEnvelopes(speed);
    }
}
